freedombone-app-matrix 17KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154155156157158159160161162163164165166167168169170171172173174175176177178179180181182183184185186187188189190191192193194195196197198199200201202203204205206207208209210211212213214215216217218219220221222223224225226227228229230231232233234235236237238239240241242243244245246247248249250251252253254255256257258259260261262263264265266267268269270271272273274275276277278279280281282283284285286287288289290291292293294295296297298299300301302303304305306307308309310311312313314315316317318319320321322323324325326327328329330331332333334335336337338339340341342343344345346347348349350351352353354355356357358359360361362363364365366367368369370371372373374375376377378379380381382383384385386387388389390391392393394395396397398399400401402403404405406407408409410411412413414415416417418419420421422423424425426427428429430431432433434435436437438439440441442443444445446447448449450451452453454455456457458459460461462463464465466467468469470471472473474475476477478479480481482483484485486487488489
  1. #!/bin/bash
  2. #
  3. # .---. . .
  4. # | | |
  5. # |--- .--. .-. .-. .-.| .-. .--.--. |.-. .-. .--. .-.
  6. # | | (.-' (.-' ( | ( )| | | | )( )| | (.-'
  7. # ' ' --' --' -' - -' ' ' -' -' -' ' - --'
  8. #
  9. # Freedom in the Cloud
  10. #
  11. # matrix server
  12. #
  13. # https://raw.githubusercontent.com/silvio/docker-matrix
  14. #
  15. # License
  16. # =======
  17. #
  18. # Copyright (C) 2016 Bob Mottram <bob@freedombone.net>
  19. #
  20. # This program is free software: you can redistribute it and/or modify
  21. # it under the terms of the GNU Affero General Public License as published by
  22. # the Free Software Foundation, either version 3 of the License, or
  23. # (at your option) any later version.
  24. #
  25. # This program is distributed in the hope that it will be useful,
  26. # but WITHOUT ANY WARRANTY; without even the implied warranty of
  27. # MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
  28. # GNU Affero General Public License for more details.
  29. #
  30. # You should have received a copy of the GNU Affero General Public License
  31. # along with this program. If not, see <http://www.gnu.org/licenses/>.
  32. VARIANTS='full full-vim chat'
  33. IN_DEFAULT_INSTALL=0
  34. SHOW_ON_ABOUT=1
  35. MATRIX_DATA_DIR='/var/lib/matrix'
  36. MATRIX_PORT=8448
  37. MATRIX_REPO="https://github.com/matrix-org/synapse"
  38. MATRIX_COMMIT='f5a4001bb116c468cc5e8e0ae04a1c570e2cb171'
  39. REPORT_STATS="no"
  40. MATRIX_SECRET=
  41. matrix_variables=(ONION_ONLY
  42. MY_USERNAME
  43. MATRIX_SECRET
  44. DEFAULT_DOMAIN_NAME)
  45. function matrix_nginx {
  46. matrix_proxy_str=' \
  47. location /matrix { \
  48. proxy_pass https://localhost:8448; \
  49. proxy_buffering on; \
  50. }'
  51. if [ ! -f /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME} ]; then
  52. matrix_nginx_site=/etc/nginx/sites-available/$DEFAULT_DOMAIN_NAME
  53. if [[ $ONION_ONLY == "no" ]]; then
  54. function_check nginx_http_redirect
  55. nginx_http_redirect $DEFAULT_DOMAIN_NAME
  56. echo 'server {' >> $matrix_nginx_site
  57. echo ' listen 443 ssl;' >> $matrix_nginx_site
  58. echo ' listen [::]:443 ssl;' >> $matrix_nginx_site
  59. echo " server_name $DEFAULT_DOMAIN_NAME;" >> $matrix_nginx_site
  60. echo '' >> $matrix_nginx_site
  61. echo ' # Security' >> $matrix_nginx_site
  62. function_check nginx_ssl
  63. nginx_ssl $DEFAULT_DOMAIN_NAME
  64. function_check nginx_disable_sniffing
  65. nginx_disable_sniffing $DEFAULT_DOMAIN_NAME
  66. echo ' add_header Strict-Transport-Security max-age=15768000;' >> $matrix_nginx_site
  67. echo '' >> $matrix_nginx_site
  68. echo ' # Logs' >> $matrix_nginx_site
  69. echo ' access_log /dev/null;' >> $matrix_nginx_site
  70. echo ' error_log /dev/null;' >> $matrix_nginx_site
  71. echo '' >> $matrix_nginx_site
  72. echo ' # Root' >> $matrix_nginx_site
  73. echo " root /var/www/$DEFAULT_DOMAIN_NAME/htdocs;" >> $matrix_nginx_site
  74. echo '' >> $matrix_nginx_site
  75. echo ' # Index' >> $matrix_nginx_site
  76. echo ' index index.html;' >> $matrix_nginx_site
  77. echo '' >> $matrix_nginx_site
  78. echo ' # Location' >> $matrix_nginx_site
  79. echo ' location / {' >> $matrix_nginx_site
  80. function_check nginx_limits
  81. nginx_limits $DEFAULT_DOMAIN_NAME '15m'
  82. echo ' }' >> $matrix_nginx_site
  83. echo '' >> $matrix_nginx_site
  84. echo ' # Restrict access that is unnecessary anyway' >> $matrix_nginx_site
  85. echo ' location ~ /\.(ht|git) {' >> $matrix_nginx_site
  86. echo ' deny all;' >> $matrix_nginx_site
  87. echo ' }' >> $matrix_nginx_site
  88. echo '}' >> $matrix_nginx_site
  89. else
  90. echo -n '' > $matrix_nginx_site
  91. fi
  92. echo 'server {' >> $matrix_nginx_site
  93. echo " listen 127.0.0.1:$MATRIX_PORT default_server;" >> $matrix_nginx_site
  94. echo " server_name $DEFAULT_DOMAIN_NAME;" >> $matrix_nginx_site
  95. echo '' >> $matrix_nginx_site
  96. function_check nginx_disable_sniffing
  97. nginx_disable_sniffing $DEFAULT_DOMAIN_NAME
  98. echo '' >> $matrix_nginx_site
  99. echo ' # Logs' >> $matrix_nginx_site
  100. echo ' access_log /dev/null;' >> $matrix_nginx_site
  101. echo ' error_log /dev/null;' >> $matrix_nginx_site
  102. echo '' >> $matrix_nginx_site
  103. echo ' # Root' >> $matrix_nginx_site
  104. echo " root /var/www/$DEFAULT_DOMAIN_NAME/htdocs;" >> $matrix_nginx_site
  105. echo '' >> $matrix_nginx_site
  106. echo ' # Location' >> $matrix_nginx_site
  107. echo ' location / {' >> $matrix_nginx_site
  108. function_check nginx_limits
  109. nginx_limits $DEFAULT_DOMAIN_NAME '15m'
  110. echo ' }' >> $matrix_nginx_site
  111. echo '' >> $matrix_nginx_site
  112. echo ' # Restrict access that is unnecessary anyway' >> $matrix_nginx_site
  113. echo ' location ~ /\.(ht|git) {' >> $matrix_nginx_site
  114. echo ' deny all;' >> $matrix_nginx_site
  115. echo ' }' >> $matrix_nginx_site
  116. echo '}' >> $matrix_nginx_site
  117. if [ ! -f /etc/ssl/certs/${DEFAULT_DOMAIN_NAME}.pem ]; then
  118. function_check create_site_certificate
  119. create_site_certificate $DEFAULT_DOMAIN_NAME 'yes'
  120. fi
  121. nginx_ensite $DEFAULT_DOMAIN_NAME
  122. fi
  123. if ! grep 'localhost:8448' /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}; then
  124. sed "s|:443 ssl;|:443 ssl;${matrix_proxy_str}|g" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  125. sed "s| default_server;| default_server;${matrix_proxy_str}|g" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  126. fi
  127. systemctl restart nginx
  128. }
  129. function matrix_generate_synapse_file {
  130. local filepath="${1}"
  131. cd /etc/matrix
  132. python -m synapse.app.homeserver \
  133. --config-path "${filepath}" \
  134. --generate-config \
  135. --report-stats ${REPORT_STATS} \
  136. --server-name ${DEFAULT_DOMAIN_NAME}
  137. }
  138. function matrix_configure_homeserver_yaml {
  139. local turnkey="${1}"
  140. local filepath="${2}"
  141. local ymltemp="$(mktemp)"
  142. awk -v TURNURIES="turn_uris: [\"turn:${DEFAULT_DOMAIN_NAME}:${TURN_PORT}?transport=udp\", \"turn:${DEFAULT_DOMAIN_NAME}:${TURN_PORT}?transport=tcp\"]" \
  143. -v TURNSHAREDSECRET="turn_shared_secret: \"${turnkey}\"" \
  144. -v PIDFILE="pid_file: ${MATRIX_DATA_DIR}/homeserver.pid" \
  145. -v DATABASE="database: \"${MATRIX_DATA_DIR}/homeserver.db\"" \
  146. -v LOGFILE="log_file: \"/dev/null\"" \
  147. -v MEDIASTORE="media_store_path: \"${MATRIX_DATA_DIR}/media_store\"" \
  148. '{
  149. sub(/turn_shared_secret: "YOUR_SHARED_SECRET"/, TURNSHAREDSECRET);
  150. sub(/turn_uris: \[\]/, TURNURIES);
  151. sub(/pid_file: \/homeserver.pid/, PIDFILE);
  152. sub(/database: "\/homeserver.db"/, DATABASE);
  153. sub(/log_file: "\/homeserver.log"/, LOGFILE);
  154. sub(/media_store_path: "\/media_store"/, MEDIASTORE);
  155. print;
  156. }' "${filepath}" > "${ymltemp}"
  157. mv ${ymltemp} "${filepath}"
  158. if [[ $ONION_ONLY != 'no' ]]; then
  159. sed -i 's|no_tls: .*|no_tls: True|g' "${filepath}"
  160. fi
  161. sed -i 's|enable_registration_captcha.*|enable_registration_captcha: False|g' "${filepath}"
  162. }
  163. function matrix_diff {
  164. DIFFPARAMS="${DIFFPARAMS:-Naur}"
  165. DEFAULT_DOMAIN_NAME="${DEFAULT_DOMAIN_NAME:-demo_server_name}"
  166. REPORT_STATS="${REPORT_STATS:-no_or_yes}"
  167. export DEFAULT_DOMAIN_NAME REPORT_STATS
  168. matrix_generate_synapse_file $INSTALL_DIR/homeserver.synapse.yaml
  169. diff -${DIFFPARAMS} $INSTALL_DIR/homeserver.synapse.yaml ${MATRIX_DATA_DIR}/homeserver.yaml
  170. rm $INSTALL_DIR/homeserver.synapse.yaml
  171. }
  172. function matrix_generate {
  173. breakup="0"
  174. [[ -z "${DEFAULT_DOMAIN_NAME}" ]] && echo "STOP! environment variable DEFAULT_DOMAIN_NAME must be set" && breakup="1"
  175. [[ -z "${REPORT_STATS}" ]] && echo "STOP! environment variable REPORT_STATS must be set to 'no' or 'yes'" && breakup="1"
  176. [[ "${breakup}" == "1" ]] && exit 1
  177. [[ "${REPORT_STATS}" != "yes" ]] && [[ "${REPORT_STATS}" != "no" ]] && \
  178. echo "STOP! REPORT_STATS needs to be 'no' or 'yes'" && breakup="1"
  179. if [ -f ${MATRIX_DATA_DIR}/homeserver.yaml ]; then
  180. rm ${MATRIX_DATA_DIR}/homeserver.yaml
  181. fi
  182. matrix_generate_synapse_file ${MATRIX_DATA_DIR}/homeserver.yaml
  183. matrix_configure_homeserver_yaml "${turnkey}" ${MATRIX_DATA_DIR}/homeserver.yaml
  184. }
  185. function remove_user_matrix {
  186. remove_username="$1"
  187. ${PROJECT_NAME}-pass -u $remove_username --rmapp matrix
  188. # TODO: There is no user removal script within synapse
  189. }
  190. function add_user_matrix {
  191. new_username="$1"
  192. new_user_password="$2"
  193. ${PROJECT_NAME}-pass -u $new_username -a matrix -p "$new_user_password"
  194. read_config_param 'MATRIX_SECRET'
  195. matrix_nginx
  196. if [ -f /var/lib/matrix/.synapse/bin/activate ]; then
  197. source /var/lib/matrix/.synapse/bin/activate
  198. fi
  199. register_new_matrix_user -c ${MATRIX_DATA_DIR}/homeserver.yaml https://${DEFAULT_DOMAIN_NAME}/matrix -u "${new_username}" -p "${new_user_password}" -a
  200. if [ ! "$?" = "0" ]; then
  201. echo '1'
  202. else
  203. echo "0"
  204. fi
  205. }
  206. function install_interactive_matrix {
  207. APP_INSTALLED=1
  208. }
  209. function change_password_matrix {
  210. curr_username="$1"
  211. new_user_password="$2"
  212. #${PROJECT_NAME}-pass -u "$curr_username" -a matrix -p "$new_user_password"
  213. }
  214. function reconfigure_matrix {
  215. echo -n ''
  216. }
  217. function upgrade_matrix {
  218. function_check set_repo_commit
  219. set_repo_commit /etc/matrix "matrix commit" "$MATRIX_COMMIT" $MATRIX_REPO
  220. pip install --upgrade --process-dependency-links .
  221. chown -R matrix:matrix /etc/matrix
  222. chown -R matrix:matrix $MATRIX_DATA_DIR
  223. }
  224. function backup_local_matrix {
  225. source_directory=/etc/matrix
  226. if [ -d $source_directory ]; then
  227. systemctl stop matrix
  228. function_check backup_directory_to_usb
  229. backup_directory_to_usb $source_directory matrix
  230. source_directory=$MATRIX_DATA_DIR
  231. if [ -d $source_directory ]; then
  232. backup_directory_to_usb $source_directory matrixdata
  233. fi
  234. systemctl start matrix
  235. fi
  236. }
  237. function restore_local_matrix {
  238. if [ -d /etc/matrix ]; then
  239. systemctl stop matrix
  240. temp_restore_dir=/root/tempmatrix
  241. function_check restore_directory_from_usb
  242. restore_directory_from_usb $temp_restore_dir matrix
  243. cp -r $temp_restore_dir/etc/matrix/* /etc/matrix
  244. if [ ! "$?" = "0" ]; then
  245. function_check backup_unmount_drive
  246. backup_unmount_drive
  247. exit 3783
  248. fi
  249. rm -rf $temp_restore_dir
  250. chown -R matrix:matrix /etc/matrix
  251. temp_restore_dir=/root/tempmatrixdata
  252. restore_directory_from_usb $temp_restore_dir matrixdata
  253. cp -r $temp_restore_dir$MATRIX_DATA_DIR/* $MATRIX_DATA_DIR
  254. if [ ! "$?" = "0" ]; then
  255. function_check backup_unmount_drive
  256. backup_unmount_drive
  257. exit 78352
  258. fi
  259. rm -rf $temp_restore_dir
  260. chown -R matrix:matrix $MATRIX_DATA_DIR
  261. systemctl start matrix
  262. fi
  263. }
  264. function backup_remote_matrix {
  265. source_directory=/etc/matrix
  266. if [ -d $source_directory ]; then
  267. systemctl stop matrix
  268. function_check backup_directory_to_friend
  269. backup_directory_to_friend $source_directory matrix
  270. source_directory=$MATRIX_DATA_DIR
  271. if [ -d $source_directory ]; then
  272. backup_directory_to_friend $source_directory matrixdata
  273. fi
  274. systemctl start matrix
  275. fi
  276. }
  277. function restore_remote_matrix {
  278. if [ -d /etc/matrix ]; then
  279. systemctl stop matrix
  280. temp_restore_dir=/root/tempmatrix
  281. function_check restore_directory_from_friend
  282. restore_directory_from_friend $temp_restore_dir matrix
  283. cp -r $temp_restore_dir/etc/matrix/* /etc/matrix
  284. if [ ! "$?" = "0" ]; then
  285. exit 38935
  286. fi
  287. rm -rf $temp_restore_dir
  288. chown -R matrix:matrix /etc/matrix
  289. temp_restore_dir=/root/tempmatrixdata
  290. restore_directory_from_friend $temp_restore_dir matrixdata
  291. cp -r $temp_restore_dir$MATRIX_DATA_DIR/* $MATRIX_DATA_DIR
  292. if [ ! "$?" = "0" ]; then
  293. exit 60923
  294. fi
  295. rm -rf $temp_restore_dir
  296. chown -R matrix:matrix $MATRIX_DATA_DIR
  297. systemctl start matrix
  298. fi
  299. }
  300. function remove_matrix {
  301. firewall_remove ${MATRIX_PORT}
  302. systemctl stop matrix
  303. function_check remove_turn
  304. remove_turn
  305. systemctl disable matrix
  306. if [ -f /etc/systemd/system/matrix.service ]; then
  307. rm /etc/systemd/system/matrix.service
  308. fi
  309. apt-get -y remove --purge coturn
  310. cd /etc/matrix
  311. pip uninstall .
  312. rm -rf $MATRIX_DATA_DIR
  313. rm -rf /etc/matrix
  314. deluser matrix
  315. delgroup matrix
  316. remove_onion_service matrix ${MATRIX_PORT}
  317. sed -i "/location \/matrix {/,/}/d" /etc/nginx/sites-available/${DEFAULT_DOMAIN_NAME}
  318. systemctl restart nginx
  319. remove_completion_param install_matrix
  320. sed -i '/matrix/d' $COMPLETION_FILE
  321. }
  322. function install_matrix {
  323. if [ ! -d $INSTALL_DIR ]; then
  324. mkdir -p $INSTALL_DIR
  325. fi
  326. if [[ ${ONION_ONLY} == 'no' ]]; then
  327. if [ ! -f /etc/ssl/certs/${DEFAULT_DOMAIN_NAME}.pem ]; then
  328. echo $'Obtaining certificate for the main domain'
  329. create_site_certificate ${DEFAULT_DOMAIN_NAME} 'yes'
  330. fi
  331. fi
  332. export DEBIAN_FRONTEND=noninteractive
  333. apt-get -yq install coreutils \
  334. curl file gcc git libevent-2.0-5 \
  335. libevent-dev libffi-dev libffi6 \
  336. libgnutls28-dev libjpeg62-turbo \
  337. libjpeg62-turbo-dev libldap-2.4-2 \
  338. libldap2-dev libsasl2-dev \
  339. libsqlite3-dev libssl-dev \
  340. libssl1.0.0 libtool libxml2 \
  341. libxml2-dev libxslt1-dev libxslt1.1 \
  342. make python python-dev \
  343. python-pip python-psycopg2 \
  344. python-virtualenv sqlite unzip \
  345. zlib1g zlib1g-dev
  346. pip install --upgrade pip
  347. pip install --upgrade python-ldap
  348. pip install --upgrade lxml
  349. if [ ! -d /etc/matrix ]; then
  350. function_check git_clone
  351. git_clone $MATRIX_REPO /etc/matrix
  352. if [ ! -d /etc/matrix ]; then
  353. echo $'Unable to clone matrix repo'
  354. exit 6724683
  355. fi
  356. fi
  357. cd /etc/matrix
  358. git checkout $MATRIX_COMMIT -b $MATRIX_COMMIT
  359. set_completion_param "matrix commit" "$MATRIX_COMMIT"
  360. if [ ! -d $INSTALL_DIR/matrix ]; then
  361. mkdir -p $INSTALL_DIR/matrix
  362. fi
  363. pip install --upgrade --process-dependency-links . -b $INSTALL_DIR/matrix
  364. if [ ! "$?" = "0" ]; then
  365. exit 782542
  366. fi
  367. function_check install_turn
  368. install_turn
  369. MATRIX_SECRET="${turnkey}"
  370. function_check matrix_generate
  371. matrix_generate
  372. if [[ -z ${MATRIX_DATA_DIR}/homeserver.yaml ]]; then
  373. echo $'homeserver.yaml is zero size'
  374. exit 783724
  375. fi
  376. groupadd matrix
  377. useradd -c "Matrix system account" -d $MATRIX_DATA_DIR -m -r -g matrix matrix
  378. chown -R matrix:matrix /etc/matrix
  379. chown -R matrix:matrix $MATRIX_DATA_DIR
  380. echo '[Unit]' > /etc/systemd/system/matrix.service
  381. echo 'Description=Synapse Matrix homeserver' >> /etc/systemd/system/matrix.service
  382. echo 'After=network.target nginx.target' >> /etc/systemd/system/matrix.service
  383. echo '' >> /etc/systemd/system/matrix.service
  384. echo '[Service]' >> /etc/systemd/system/matrix.service
  385. echo 'Type=simple' >> /etc/systemd/system/matrix.service
  386. echo 'User=matrix' >> /etc/systemd/system/matrix.service
  387. echo "WorkingDirectory=/etc/matrix" >> /etc/systemd/system/matrix.service
  388. echo "ExecStart=/usr/bin/python -m synapse.app.homeserver --config-path ${MATRIX_DATA_DIR}/homeserver.yaml" >> /etc/systemd/system/matrix.service
  389. echo 'Restart=always' >> /etc/systemd/system/matrix.service
  390. echo 'RestartSec=10' >> /etc/systemd/system/matrix.service
  391. echo '' >> /etc/systemd/system/matrix.service
  392. echo '[Install]' >> /etc/systemd/system/matrix.service
  393. echo 'WantedBy=multi-user.target' >> /etc/systemd/system/matrix.service
  394. systemctl enable matrix
  395. systemctl daemon-reload
  396. systemctl start matrix
  397. update_default_domain
  398. firewall_add matrix ${MATRIX_PORT}
  399. MATRIX_ONION_HOSTNAME=$(add_onion_service matrix ${MATRIX_PORT} ${MATRIX_PORT})
  400. if [ ! ${MATRIX_PASSWORD} ]; then
  401. if [ -f ${IMAGE_PASSWORD_FILE} ]; then
  402. MATRIX_PASSWORD="$(printf `cat $IMAGE_PASSWORD_FILE`)"
  403. else
  404. MATRIX_PASSWORD="$(create_password ${MINIMUM_PASSWORD_LENGTH})"
  405. fi
  406. fi
  407. rm -rf ${MATRIX_DATA_DIR}/Maildir
  408. rm -rf ${MATRIX_DATA_DIR}/.mutt
  409. rm -f ${MATRIX_DATA_DIR}/.muttrc
  410. rm -f ${MATRIX_DATA_DIR}/.mutt-alias
  411. rm -f ${MATRIX_DATA_DIR}/.procmailrc
  412. rm -f ${MATRIX_DATA_DIR}/.emacs-mutt
  413. matrix_nginx
  414. if [[ $(add_user_matrix "${MY_USERNAME}" "${MATRIX_PASSWORD}") != "0" ]]; then
  415. echo $'Failed to add matrix admin user';
  416. exit 879352
  417. fi
  418. APP_INSTALLED=1
  419. }